//	+---------------------------+
//	|	Informy					|
//	+---------------------------+
//	|	Version: 1.0			|
//	|	Released: Jan 2, 2014	|
//	|	Author: Zapk | 12270	|
//	+---------------------------+

$Informy::Milliseconds = 100;

function Informy()
{
	exec("Add-Ons/Script_Informy/server.cs");
}

function Player::informyTick(%this)
{
	cancel(%this.informyTick);
	
	%raycast = containerRaycast(%eye = %this.getEyePoint(), VectorAdd(%eye, VectorScale(%this.getEyeVector(), 5)), $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::ItemObjectType, %this);
	
	%client = %this.client;
	%style = "<just:left><font:impact:25>";
	%seconds = ($Informy::Milliseconds / 1000) * 1.5;
	
	if(isObject(%object = firstWord(%raycast)))
	{	
		%class = %object.getClassName();
		if(%class $= "fxDTSBrick")
		{
			%bl_id = %object.stackBL_ID;
			if(%bl_id == -1)
			{
				%bl_id = getNumKeyID();
			}
			
			if(isObject(%group = "BrickGroup_" @ %bl_id))
			{
				%name = %group.name;
			}
			
			%type = %object.getDatablock().uiName;
			
			if(isObject(%object.AudioEmitter))
			{
				%song = %object.AudioEmitter.profile.uiName;
			}
			
			centerPrint(%client, %style @ "\c4" @ %type @ "<br>\c6Owner: \c4" @ %name @ "<br>\c6Blockland ID: \c4" @ %bl_id @ (%song !$= "" ? "<br>\c6Music Data: \c4" @ %song : ""), %seconds);
		}
		else if(%class $= "Player")
		{
			%damage = %object.getDatablock().maxDamage - %object.getDamageLevel();
			%health = %damage / %object.getDatablock().maxDamage * 100;
			%name = %object.client.name;
			%bl_id = %object.client.bl_id;
			
			centerPrint(%client, %style @ "\c4" @ %name @ "<br>\c6Health: \c4" @ %health @ "%<br>\c6Blockland ID: \c4" @ %bl_id, %seconds);
		}
		else if(%class $= "AIPlayer")
		{
			%damage = %object.getDatablock().maxDamage - %object.getDamageLevel();
			%health = %damage / %object.getDatablock().maxDamage * 100;
			
			if(!isObject(%object.spawnBrick))
			{
				centerPrint(%client, %style @ "\c4Bot<br>\c6Health: \c4" @ %health @ "%", %seconds);
			}
			else
			{
				%bl_id = %object.spawnBrick.stackBL_ID;
				
				if(isObject(%group = "BrickGroup_" @ %bl_id))
				{
					%name = %group.name;
				}
				
				centerPrint(%client, %style @ "\c4AI Object<br>\c6Health: \c4" @ %health @ "%<br>\c6Owner: \c4" @ %name @ "<br>\c6Blockland ID: \c4" @ %bl_id, %seconds);
			}
		}
		else if(%class $= "WheeledVehicle")
		{
			%damage = %object.getDatablock().maxDamage - %object.getDamageLevel();
			%health = %damage / %object.getDatablock().maxDamage * 100;
			
			if(!isObject(%object.spawnBrick))
			{
				centerPrint(%client, %style @ "\c4Bot<br>\c6Health: \c4" @ %health @ "%", %seconds);
			}
			else
			{
				%bl_id = %object.spawnBrick.stackBL_ID;
				
				if(isObject(%group = "BrickGroup_" @ %bl_id))
				{
					%name = %group.name;
				}
				
				%type = %object.getDatablock().uiName;
				
				centerPrint(%client, %style @ "\c4" @ %type @ "<br>\c6Health: \c4" @ %health @ "%<br>\c6Owner: \c4" @ %name @ "<br>\c6Blockland ID: \c4" @ %bl_id, %seconds);
			}
		}
		else if(%class $= "Item")
		{
			%bl_id = %object.bl_id;
			%name = findClientByBL_ID(%bl_id).name;
			
			%type = %object.getDatablock().uiName;
			
			centerPrint(%client, %style @ "\c4" @ %type @ (%name !$= "" ? "<br>\c6Dropped By: \c4" @ %name : "") @ (%bl_id !$= "" ? "<br>\c6Blockland ID: \c4" @ %bl_id : ""), %seconds);
		}
	}
	
	%position = %this.getPosition();
	%x = mFloatLength(getWord(%position, 0), 0);
	%y = mFloatLength(getWord(%position, 1), 0);
	%z = mFloatLength(getWord(%position, 2), 0);
	
	%damage = %this.getDatablock().maxDamage - %this.getDamageLevel();
	%health = %damage / %this.getDatablock().maxDamage * 100;
	
	bottomPrint(%client, %style @ "\c6Position: \c4" @ %x SPC %y SPC %z @ "<br>\c6Health: \c4" @ %health @ "%", %seconds, true);
	
	%this.informyTick = %this.schedule($Informy::Milliseconds, informyTick);
}

if(isPackage("InformyPackage"))
{
	deactivatePackage("InformyPackage");
}

package InformyPackage
{
	function gameConnection::spawnPlayer(%this)
	{
		Parent::spawnPlayer(%this);
		
		%player = %this.player;
		%player.informyTick = %player.schedule($Informy::Milliseconds, informyTick);
	}
};

activatePackage("InformyPackage");